<?php
	
	class meta_search extends WC_API_Resource {
		
		protected $base = '/meta_search';
		
		public function register_routes( $sroutes ) {
			
			# GET /get customer or product ids
			
			$sroutes[ $this->base ] = [
				[ [ $this, 'search_meta' ], WC_API_Server::READABLE ],
			];
			
			return $sroutes;
		}
		
		public function search_meta() {
			
			
			
			if ( ! empty( $_GET["contactinternalid"] ) && !empty($_GET['customerinternalid']) ) {
				global $wpdb;
				$ciid    = $_GET["contactinternalid"];
				$tble    = $wpdb->prefix . "usermeta";
				$query   = "SELECT user_id FROM " . $tble . " WHERE meta_key = 'contactinternalid' AND meta_value = '%d'";
				$sql     = $wpdb->prepare( $query, $ciid );
				$cresult = $wpdb->get_results( $sql );
				
				echo json_encode( [ "result" => $cresult ] );
				exit;
			}
			
			
			if ( ! empty( $_GET["customerinternalid"] ) ) {
				global $wpdb;
				$ciid    = $_GET["customerinternalid"];
				$tble    = $wpdb->prefix . "usermeta";
				$query   = "SELECT user_id FROM " . $tble . " WHERE meta_key = 'customerinternalid' AND meta_value = '%d'";
				$sql     = $wpdb->prepare( $query, $ciid );
				$cresult = $wpdb->get_results( $sql );
				
				// filter out the contacts
				$newResults = [];
				foreach($cresult as $result){
					$contactInternalId = get_user_meta($result->user_id, 'contactinternalid', true);
					if( empty($contactInternalId) ){
						$newResults[] = $result;
					}
				}
				$cresult = $newResults;
				
				echo json_encode( [ "result" => $cresult ] );
				exit;
			}
			
			if ( ! empty( $_GET["iteminternalid"] ) ) {
				global $wpdb;
				$piid     = $_GET["iteminternalid"];
				$tble     = $wpdb->prefix . "postmeta";
				$query    = "SELECT post_id FROM " . $tble . " WHERE meta_key = 'internalid' AND meta_value = '%d'";
				$sql      = $wpdb->prepare( $query, $piid );
				$presults = $wpdb->get_results( $sql );
				//filter results to not include post type shop_order
				$tble = $wpdb->prefix . "posts";
				foreach ( $presults as $key => $presult ) {
					$query  = "SELECT post_type FROM " . $tble . " WHERE ID = '%d'";
					$sql    = $wpdb->prepare( $query, $presult->post_id );
					$result = $wpdb->get_row( $sql );
//	            if ( $result->post_type == "shop_order" ) {
					if ( in_array( $result->post_type, [ 'shop_order', 'shop_coupon' ] ) ) {
						unset( $presults[ $key ] );
					}
				}
				
				echo json_encode( [ "result" => $presults ] );
				exit;
			}
		}
		
	}
